UBYTE TimedWaitIO( struct IORequest *areq, ULONG wbit, ULONG secs );
void LoadInfo( void );

void SetDownloadCredits( void );
void AdoptQWK( void );
void GetBaseUser( short id, struct BaseUser *bp );
void PutBaseUser( short id, struct BaseUser *bp );

BPTR OpenPost( BPTR was );
void EditItems( void );
UBYTE EditOne( long r );
void FastFind( void );
UBYTE FindFile( long *n, char *name, short base );
void RemoveFile( char *name, short base );
void AddFile( struct FileType *f );

char *RexxGetUser( char *arg );
char *RexxPutUser( char *arg );

UBYTE ReadHeader( BPTR fh, long pos, struct HeaderType *head );
long GetCount( struct NewSubboardType *s );
long LoadFree( struct NewSubboardType *s, long extra );
long SaveFree( struct NewSubboardType *s );
long AllocText( struct NewSubboardType *s, long length );
long FreeText( struct NewSubboardType *s, long pos, long length );
void BaseSaveEditor( BPTR fh, short num );
long SizeOfMessage( short num );
long SaveText( long prev, short sig );
long SaveResponse( void );
long SaveItem( short sig );
long KillResponse( long pos );
long NewText( long pos, short sig );
long EditResponse( long pos );

UBYTE OneMoreUser( short r );
void OneLessUser( short r );

void YMarkRec( BPTR kp, long pos, struct HeaderType *head );
void MarkReceived( char *path, long pos );
long LocateResponse( BPTR fh, long resp );
void GetAllItems( void );
void AdoptLocalDefaults( void );

void ReadM0( void );
void SetSubStuff( short base );
void ShowSubTitle( void );

void ReadMarked( void );
void ExtSetMinFree( long free );
UBYTE ExtSetProtocol( char a );
char *ExtDownload( char *args );
char *ExtUpload( char *args );

void FixCase( USHORT opts );
void MakePath( char *where );
void ChangeExchange( void );
void SetCapture( void );
void OpenCapture( char force );
void WriteSubboard( void );
short SetSigNumber( short num );
void OpenYank( short parm );
void ReadOne( void );
void GetMessage( long b );
void Rquery( char *command, char *def );
short replace( char *from, char *with );
UBYTE GoItem( UBYTE nof, UBYTE file );
UBYTE IsPrivate( void );
UBYTE ReadJoined( struct BaseUser **p, short r );
void ExitSubboard( UBYTE quiet );
UBYTE ChangeDate( struct IsDate *date );
void ChangeNew( void );
UBYTE Rsetup( UBYTE deftype, UBYTE chrono );
UBYTE Rnext( void );
char KillOne( void );
void SToUpper( char *s );
void AMLogWrite( char *line );
void ArrangeItemPointers( void );
UBYTE SearchOne( void );

void MultiMail( struct MailHeader *rh );
UBYTE MailSetup( UBYTE feedback );
void MailCount( short i );
void ExitSubboard( UBYTE quiet );

void SendToMailBox( void );
void ScanForNewUploads( void );
short VisualDataEditor( char *file, void *data, long size );

short CountMail( char *filename, short *nnew );
void ShowMailHeader( struct MailHeader *m, short number, short of, short samv );
UBYTE SelectAndDownload( char *file, UBYTE now );

void LoadSelectList( void );
void SaveSelectList( void );

void LoadBaseUser( void );
void SaveBaseUser( void );

void LogOffUser( void );
void TermLink( void );
void DoPortMonitor( void );
void DoTermLink( void );
void DoSimpleRange( long min, long max, long defmin, long defmax );
long GetNext( void );

void SetByAndTo( void );
UBYTE existf( char *name );
void AdoptItemStuff( void );
void SetItemStuff( UBYTE qwk );
void TestOne( void );
void TestItems( void );
void TransformOne( void );
void TransformItems( void );

void AskAPlan( UBYTE time );
void AskBPlan( UBYTE time );
void SafeFreeMem( void *b, int s );
void dispRexxPort( void );
void NormalizeScreen( void );
void CallXPR( void );
UBYTE ChangeDir( char *name );
void BrowseItems( void );
void EraseChat( void );
UBYTE *FilePart( UBYTE *a );
void GetSkyBrush( BPTR fd );
void LoadBBSCharges( void );
short LoadBBSText( char *loc, char **bm, char *name, long size );
void LoadXLation( short t );
void NormalizeColors( void );
void ResetSRead( UBYTE on );
void Rreset( void );
UBYTE RunParagon( char *name );
UBYTE RunC( char *name );
UBYTE RunCPfile( char *name );
UBYTE RunRexx( char *name );
void sendcanx( void );
void SetCreditStuff( void );
void SetSelect( UBYTE *a );
void SetUtilityClock( long mics );
void ShowAccess( void );
void ShowTimeLeft( void );
char WaitForInput( long mics );
UBYTE YesNo( UBYTE def );

void PutError( char *what );
void GotoResponse( long n, BPTR fh );
short FindArc( char *name );
UBYTE CheckSysPassword( short x, char *banner );
long GiveAmigaDays( struct IsDate *date );
void SilentUpload( char p );
void SilentDownload( char p );
UBYTE Unknown( void );
UBYTE CheckBBSTimes( void );
UBYTE ReadGraphics( char *f, char fnf );
void WriteLog( short n, char *text1, char *text2 );
void VerifyOff( void );
void ReadAccount( short i, struct UserData *user );
long FindPhone ( short *n, char *phone, short id );
long FindHandle( short *n, char *name,  short id );
void WaitScreen( void );
void ModemCommand( char *s );
UBYTE WaitForCall( void );
void LogonScreen( void );
void ResetLine( void );
UBYTE ClearLine( void );
void UserStatus( struct UserData *user, short ii );
short FindAccount( char *text, struct UserData *user );
void UpdateAccess( void );
void CheckChanges( void );
long CommonCommands( void );
UBYTE ReadLog( char *f );
void SendMail( BPTR fh );
short FollowForward( short id, struct UserData *u );
short WriteMail( struct MailHeader *m, char type, BPTR fh,
	short id, struct UserData *u,
	UBYTE overrider, UBYTE saveopts );
UBYTE CheckUrgentMail( void );
void CheckMail( void );
void ReadMail( char *filename, short samv );
void CopyMessage( BPTR fh, BPTR kh );
void TimeDate( void );
void Feedback( void );
UBYTE LoginUser( void );
void SetColors( short off );
short CalculateAge( struct UserData *user );
void OpenChat( void );
void CloseChat( void );
void CloseDisplay( void );
UBYTE OpenDisplay( void );
void WriteSAMSummary( void );
void BadLogonReason( char *s );
void ParseCommandLine( void );
short FindCommand( short menu );

UBYTE GetFilename( char *action );
void ReadDirectory( void );
void EntryPath( UBYTE exit );
void EditEntryFile( UBYTE exit );
void EntryFile( UBYTE exit );
void ListSubboards( void );
short SkipDrop( short d );
long ListSelected( UBYTE optdel );
short FindSelect( char *name );
short FindUpload( char *name );
void NothingSelected( void );
void NotValidated( void );
void EnterBase( char *dir );
void Base( char *dir );
void ExitBase( UBYTE quiet );
UBYTE OtherStuff( short r, UBYTE quiet );
void MoveToList( short r );
void MoveToSub( short r, UBYTE quiet );
void SetNewMessages( UBYTE quiet );
void SetThePrompt( void );
UBYTE NewItem( struct IsDate *date, struct IsDate *base );
int GetItemNumber( void );
void PostMessage( UBYTE qwk );
UBYTE OKFilename( char *name );
void UploadFiles( void );
void FileItem( void );
void NextItem( void );
void LastPost( void );
void NoNumber( void );
void OutScan( void );
void ScanItems( void );
char DoAnonymous( UBYTE to );
void AboutPost( UBYTE new );
void ValidateOne( void );
void ValidateItems( void );
void PutItem( short b );
void GetItem( short b );
void PrintOption( char *s, UBYTE *o );
char KillOne( void );
void KillItems( void );
void RemovePost( UBYTE killit );
void SaveHeaders( void );
void GrabItems( void );
UBYTE GrabOne( void );
void GrabFile( char *name );
void DownloadFiles( void );
void PostHeader( void );
void MessageHeader( void );
void ReadItems( void );
void AskDescription( void );
void AddDescription( void );
UBYTE PromptFileNote( char *filename );
void AddFileNote( char *file );
void LimitEditor( char *loc );
UBYTE SetFrom( void );
void SetMessageStuff( UBYTE qwk );
void TextMessage( UBYTE save );
void RespondOne( UBYTE qwk );
void RespondItems( void );
int ScanAll( void );
int ScanNew( UBYTE quiet );
int BetweenNew( void );
UBYTE ViewSubOps( short *ids );
void MailSubOps( void );
void DescribeOne( void );
void DescribeItems( void );
void SelectOne( UBYTE remove );
void SelectItems( UBYTE remove );
void SelectFile( UBYTE counttime, UBYTE remove );
void RemoveSelect( short i );
void RemoveUpload( short i );
void ExtractOne( void );
void ExtractItems( void );
void ExtractFile( char *name );
void SToLower( char *s );
void CheckString( char *string );
void SearchHere( void );
UBYTE SearchText( UBYTE filters );
void SearchEnd( void );
void TraverseAll( int (*Func1)( void ), int(*Func2)( void ) );
int TimeEstimate( int bytes );
void AdoptOrphans( void );
void DescribeBatch( void );
UBYTE CheckPrivacy( struct HeaderType *h, UBYTE quiet );
UBYTE PrivateItem( void );
UBYTE VerifyKill( void );
void MakeLoc( struct NewSubboardType *s, short p );
void FindLoc( void );
long FindLargest( UBYTE quiet );

short GetWhichPort( UBYTE MustBeOn);
void SendOLM( void );
UBYTE FileOLM( short port, int nlines );
void ReadOLM( void );
long ConferenceWait( short r );
int EnterText( char firstkey, short max, short perline, short maxlines );
void WhosHere( void );
void HideOpts( char **text, UBYTE *all, long *value );
void CheckTellMe( char *s );
void InterUserChat( short port );
void ChatRequest( void );
UBYTE CheckIUC( USHORT opts );

UBYTE RunDOS( char *name, char *arguments, UBYTE flags );
void AddToBuffer( char c );
long FileSize( char *path );
long GrabFileSize( UBYTE quiet );
int ListDir( UBYTE add, UBYTE counttime, struct IsDate *date );
UBYTE OkName( char *n );
void GetInfo( char *name, char *output );
long GetFree( char *where, UBYTE quiet );
void FindUnits( ULONG size, char *unit, ULONG chunk );

void EditorPrint( char *text );

void MakeEd( char *path );
void DeleteEd( void );
BPTR OpenEd( long mode );
void PrepEditor( BPTR fh );
void CallEditor( short max, short inlines );
void SaveEditor( BPTR fh, UBYTE eof );
char LineEditor( short max, UBYTE flags );
void DoMCIRead( void );
UBYTE CJustify( char *prompt, void (*fn)() );
void PutString( short line, short ww );
void InsPoint( short line );
void InsChar( short line, short col, short n );
void DelChar( short line, short col, short n );
void DelPoint( short line );
void FunctLoop( void (*funct)(), short returns );
void BetterFindParts( char *buffer, long min, long max );
void EdFindParts( UBYTE d );
void FList( long line );
void FnRead( long line );
void FEdit( long line );
void FReplace( long line );
void FToggle( long line );
void CDelete( void );
void CBorder( void );
void FCopy( long line );
void CCopy( short *line );
void FLeft( long line );
void FRight( long line );
void FCenter( long line );
void FPacked( long line );
void FIndent( long line );
void FUnindent( long line );
void FExpand( long line );
void FFind( long line );
void CGet( void );
void CPut( void );
void MakePrompt( char *s );

void PrintAGraph( void );
void AddSAM( short a, long b );
void DelSAM( short a, long b );
void DisplaySAM( void );
void SaveSAM( void );
short FindOnLine( short u );
void EditAccount( void );
UBYTE KillAccount( short ii );
int EditHelp( UBYTE x );
void EditGroup( short g );
void EditPrivs( struct Privs *p );
void EditPrivFlags( struct Privs *p );
void AccountSummary( UBYTE detail );
void PrintSigned( int n, char *s );
UBYTE CheckBalance( short n, short a );
UBYTE AddCharge( short n, short a );
void MyCredits( struct UserData *u );

short compstra( char *s, char *t );
void ResetServ( UBYTE reset, UBYTE time );
void AddKeyBuffer( char *c );
void ConGetChar( void );
void SerGetChar( void );
void ClearBuffer( void );
long GetABunch( char *buffer, long number );
void PutChar( char s );
char GetChar( ULONG mask );
void PrintAnything( char *s );
void DoPause( void );
void PrintSlow( char *wherefrom, short howmany );
void WaitModem( void );
void CursorOff( void );
void CursorOn( void );
void PrintWorkbench( char *where, short howmany );
void PrintPrinter( char *wherefrom, short howmany );
void PrintConsole( char *where, short howmany );
void PrintModem( char *where, short howmany );
char GetKey( void );
void ScreenBS( void );
void DoBackspace( short count );
void ScrollUp( void );
void DoReturn( void );
UBYTE ShowAbortKey( void );
void CheckFlowControl( void );
void PutText( char *wherefrom );
UBYTE PutQ( char *a );
void PutA( void );
void SetBaudRate( ULONG baud );
void Service( void );
void CheckCarrier( void );
void EnterPassword( UBYTE maxlen );
UBYTE DoANSIBox( UBYTE maxlen, USHORT opts, char *prompt, short len );
int EnterLine( UBYTE maxlen, USHORT opts, char *prompt );
UBYTE CheckInputChar( void );
UBYTE ReadFile( char *filename, UBYTE fnf );
void ReadMessage( BPTR fh );
void ReadMessagePoint( char *name, long pos );
UBYTE LoadLine( BPTR fh, char *line, short w, short flags );
void EditMessage( char *file );
void MakeDate( struct IsDate *date, char *whereto );
void MakeStdDate( struct IsDate *date, char *whereto );
void GetDate( void );
void FormDate( struct IsDate *date, long *parts );
void ResetTime( void );
void StatPrint( char *text, int XOffset, int YOffset, UBYTE colors );
void DisplayStatScreen( void );
void ShowCredits( void );
void LoAccess( void );
UBYTE NoMessages( void );
void ExpandFlags( long def, char *where );
long EnterAccess( char *prompt, long def );
long ConvertAccess( char *s );
char *PrintAccess( int a, short n );
char DeadKeyConvert( struct IntuiMessage *msg );
void Print40( void );
void ResetEnviron( void );
void ResetFont( void );
void AttemptOpenDisplay( void );

void ListItems( void );
void AddItem( void );
void SaveItemList( void );
void KillItem( short i, UBYTE quiet );
void EditItem( short i );
UBYTE MakeChanges( struct ListItem *f );
void CheckNews( void );
void DoItem( struct ListItem *f );
void DoFiles( short n );
UBYTE ObtainPfile( char *name, UBYTE restrict );
void ReleasePfile( void );
void AlphabetizeItems( void );

void DoMCI( char *string );
void PutNumber( ULONG n );
void SOHelp( short n );
void DoStillOn( void );
void DoCCG( char c );
void DoANSI( UBYTE n, USHORT a, USHORT b );
void DoANSIOut( UBYTE n );
void EraseLineEnd( void );
void EraseLineBegin( void );
void AScrollUp( short line, short num );
void AScrollDown( short line, short num );
void DoSky( short which );
void FreeSkyBrush( void );

void SaveAlpha( void );
void SaveNos( void );
UBYTE DoGeneral( struct UserData *user2, short n );
UBYTE EditProfile( struct UserData *u, short n, short id );
void NewUser( void );
void SaveUser( struct UserData *udata, short id );
UBYTE CheckBadFiles( char *f, char *s, char *d );
short CheckHandle( void );
void EditGeneral( struct UserData *user2, short i );
UBYTE EditPrefs( void );
UBYTE EditParams( struct UserData *user );
UBYTE DisplayList( char **text, short n, char *prompt, short def );
void ListComp( void );
void AutoCBV( struct UserData *user, short force );

void ToggleBott( char mode );
void ToggleStat( char mode );
void DoWEdit( UBYTE c );
void SetDoing( char *what );
void InitMenu( void );
void ControlCommand( short c );

void Terminal( void );
void DoTermMenu( long code );
void AdjustPath( void );

void CarriageReturn( void );
void ClearStr( void );
short Findend( void );
void PutStr1( void );
void GetStr( void );
void Position( void );
void Position2( void );
void OutLine( short col );
void ClearToEnd( void );
short DoVisual( void );
void DoInsLine( void );
void DoEOP( void );
void VInsChar( short n );
void SetOut( void );
void GoCorner( void );
void GoHome( UBYTE title );
void SendHome( void );
void GoLeft( void );
void GoRight( void );
void GoUp( void );
void SinsMany( short a );
void SdelMany( short a );
void GoDown( void );
void DoLeft( void );
void DoRight( void );
UBYTE DoBS( void );
void DoCR( void );
void VDelChar( short x );
UBYTE DoDelete( void );
void DoTab( void );
void DoILine( void );
void DoDLine( void );
void Pullups( void );
void RemoveMCI( char *b );

void zprprotocol( char *a );
void printsize( ULONG size );
void zprbytes( long val );
void zprblocks( USHORT b );
void zprblocksize( USHORT b );
void printerrors( long e );
void plotstatus( char *message );
void ploterrors( char *message );
void plotblockcheck( char *message );
void zprname( char *a );
void endxfer( void );
void AddDownload( void );
void AddCredits( UBYTE justadd, short m );
void DLoadSelect( UBYTE optdel );
void ULoadSelect( void );
void XAddFile( void );
UBYTE CheckTime( void );
UBYTE DCheckOK( struct SelectType *sp, short number );
UBYTE UCheckOK( UBYTE mode );
UBYTE OKProtocol( void );
UBYTE ChooseProtocol( struct UserData *u );
UBYTE MatchProtocol( UBYTE what );
UBYTE XOptions( char p, char *go );
void LogTransfer( char type, UBYTE log );
void AddTimeBenefit( void );
void CheckVerification( void );
void CloseTransfer( void );
UBYTE OpenTransfer( void );
UBYTE AvailableCredits( long *a, long *b );

void  CapsFirst( char *s );
void  AlterDate( struct IsDate *date, long i );
short instr( char *s, char *t );
